﻿namespace UltraGridSaveCancleChanges
{
    using System;
    using System.ComponentModel;
    using System.Drawing;
    using System.Windows.Forms;

    using Infragistics.Win.UltraWinGrid;

    public partial class Form1 : Form
    {
        private Infragistics.Win.Appearance uncommitedRows = new Infragistics.Win.Appearance();
        private Infragistics.Win.Appearance normalRows = new Infragistics.Win.Appearance();

        public Form1()
        {
            this.InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // TODO: This line of code loads data into the 'myDataBaseDataSet.MyData' table. You can move, or remove it, as needed.
            this.myDataTableAdapter.Fill(this.myDataBaseDataSet.MyData);
            this.ultraGrid1.UpdateMode = UpdateMode.OnUpdate;

            this.ultraGrid1.Anchor = AnchorStyles.Bottom | AnchorStyles.Left | AnchorStyles.Right | AnchorStyles.Top;

            this.normalRows = this.ultraGrid1.Rows[0].Appearance;
            this.uncommitedRows.BackColor = Color.Red;
            this.uncommitedRows.ForeColor = Color.White;
        }

        private void ButtonSave_Click(object sender, EventArgs e)
        {

            foreach (UltraGridRow row in this.ultraGrid1.Rows)
            {
                if (row.DataChanged)
                {
                    row.Appearance = this.normalRows;
                }
            }

            this.ultraGrid1.UpdateData();
            this.myDataBaseDataSet.AcceptChanges();
        }

        private void ButtonCancle_Click(object sender, EventArgs e)
        {
            foreach (UltraGridRow row in this.ultraGrid1.Rows)
            {
                if (row.DataChanged)
                {
                    row.Appearance = this.normalRows;
                }
            }

            this.ultraGrid1.UpdateData();
            this.myDataBaseDataSet.RejectChanges();
        }

        private void UltraGrid1_BeforeRowDeactivate(object sender, CancelEventArgs e)
        {
            UltraGrid grid = (UltraGrid)sender;
            if (grid != null)
            {
                UltraGridRow activeRow = grid.ActiveRow;
                if (activeRow != null && activeRow.DataChanged)
                {
                    activeRow.Appearance = this.uncommitedRows;
                }
            }
        }

        private void UltraGrid1_AfterRowUpdate(object sender, RowEventArgs e)
        {
            e.Row.Appearance = this.normalRows;
        }
    }
}
